"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostOverride = exports.ThreadOverride = exports.BoardOverride = exports.SiteOverride = exports.Option = exports.meta = void 0;
var meta = {
    name: "kakolog",
    siteKey: "kakolog.jp"
};
exports.meta = meta;
var Option = {
    // site
    encoding: 'utf8',
    // board
    dsv_board_header: ['location', 'threadkey', 'title', 'resnum', 'pubdate'],
    board_load_atonce: 1,
    // thread
    dsv_thread_header: ['name', 'dateid', 'body', 'title'],
    archivable: false,
    _kakolog_cgi_path: "/ajax/ajax_search.v16.cgi",
};
exports.Option = Option;
var SiteOverride = {
    uo_regexp: function () {
        var _this = this;
        var regs = [];
        var rep_table = {
            '-': '%2D',
            '_': '%5F',
            '.': '%2E',
            '!': '%21',
            '~': '%7E',
            '*': '%2A',
            '\'': '%27',
            '(': '%28',
            ')': '%29'
        };
        regs.push([
            RegExp(/^https:\/\/(kakolog\.jp)\/q\/(.+)/),
            function (m) {
                var uo = {};
                var word = m[2].replace(/[\-_\.\!~\*'\(^)]/g, function (s) { return rep_table[s] || ""; });
                uo['type'] = 'thread';
                uo['sitename'] = "kakolog.jp";
                uo['ssl'] = true;
                uo['server'] = m[1];
                uo['board'] = word;
                uo['threadkey'] = 'links';
                uo['location'] = _this.urlize(uo);
                return uo;
            }
        ]);
        regs.push([
            RegExp(/^https:\/\/(kakolog\.jp)\/\?q=([^&]+)(.*)$/),
            function (m) {
                var uo = {};
                var word = m[2].replace(/[\-_\.\!~\*'\(^)]/g, function (s) { return rep_table[s] || ""; });
                var opts = m[3];
                var board_key = [word, "", ""];
                if (opts.match(/d=(\d\d\d\d)/)) {
                    board_key[1] = RegExp.$1;
                }
                if (opts.match(/bbs=(\w+)/)) {
                    board_key[2] = RegExp.$1;
                }
                uo['type'] = 'board';
                uo['sitename'] = "kakolog.jp";
                uo['ssl'] = true;
                uo['server'] = m[1];
                uo['board'] = board_key.join(".").replace(/\.+$/, "");
                uo['location'] = _this.urlize(uo);
                return uo;
            }
        ]);
        return regs;
    },
    urlize: function (uo, settype) {
        var url = '';
        var t = settype || uo.type;
        if (t === 'thread') {
            url = "http".concat(uo.ssl ? 's' : '', "://").concat(uo.server, "/q/").concat(uo.board);
        }
        else if (t === 'board') {
            var _a = __read(uo.board.split(/\./), 3), word = _a[0], year = _a[1], bbs = _a[2];
            url = "http".concat(uo.ssl ? 's' : '', "://").concat(uo.server, "/?q=").concat(word);
            if (year && year.match(/^(1999|20\d\d)/)) {
                url = "".concat(url, "&d=").concat(RegExp.$1);
            }
            if (bbs && bbs.match(/^\w+$/)) {
                url = "".concat(url, "&bbs=").concat(bbs);
            }
        }
        else if (t === 'site') {
            url = "http".concat(uo.ssl ? 's' : '', "://").concat(uo.server, "/");
        }
        return url;
    },
};
exports.SiteOverride = SiteOverride;
var BoardOverride = {
    subject_url: function (page) {
        var _a = __read(this.uo.board.split(/\./), 3), word = _a[0], year = _a[1], bbs = _a[2];
        var q = ["q=".concat(word), "custom_resnum_dir=up"];
        var url = "https://".concat(this.uo.server, "/").concat(this.site_option._kakolog_cgi_path);
        if (year) {
            q.push("d=".concat(year));
        }
        if (bbs) {
            q.push("bbs=".concat(bbs));
        }
        if (page) {
            q.push("p=".concat(page));
        }
        return "".concat(url, "?").concat(q.join('&'));
    },
    adjust_subject: function (raw) {
        var e_1, _a;
        var txt = [];
        try {
            var j = JSON.parse(raw);
            try {
                for (var _b = __values(j.list), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var o = _c.value;
                    var location = "https://".concat(o.server || '5ch.net', "/test/read.cgi/").concat(o.bbs, "/").concat(o.bbskey, "/");
                    var title = o.title;
                    var resnum = o.resnum;
                    txt.push([location, o.id, title, resnum, o.bbskey + '000'].join(this.site_option.dsv_board_delimiter));
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        catch (e) {
        }
        return txt.join("\n");
    },
    fetch_setting: function (workspaceid) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, word, year, bbs, title, res;
            return __generator(this, function (_b) {
                _a = __read(this.uo.board.split("."), 3), word = _a[0], year = _a[1], bbs = _a[2];
                title = "\"".concat(decodeURIComponent(word), "\"");
                if (year) {
                    title = "".concat(title, " / ").concat(year);
                }
                if (bbs) {
                    title = "".concat(title, " / ").concat(bbs);
                }
                res = {
                    body: "BBS_TITLE=".concat(title)
                };
                return [2 /*return*/, res];
            });
        });
    }
};
exports.BoardOverride = BoardOverride;
var ThreadOverride = {
    thread_url: function (page) {
        var url = "https://kakolog.jp/".concat(this.site_option._kakolog_cgi_path);
        var q = ["q=".concat(this.uo.board), "mode=info"];
        return "".concat(url, "?").concat(q.join("&"));
    },
    datify: function (raw) {
        var _this = this;
        var lines = [];
        var now = new Date();
        try {
            var _a = JSON.parse(raw).info, by_bbs = _a.by_bbs, years = _a.years;
            if (years) {
                years.reverse().map(function (y) {
                    if (y.count > 0) {
                        if (y.year === "live") {
                            lines = __spreadArray([['', "", "\u73FE\u884C\u30B9\u30EC\u30C3\u30C9 ".concat(y.count, "\u4EF6 <br> https://").concat(_this.uo.server, "/?q=").concat(_this.uo.board.split(".")[0])]], __read(lines), false);
                        }
                        else {
                            lines.push(['', "".concat(y.year, "/01/01 00:00:00"), "".concat(y.year, "\u5E74 ").concat(y.count, "\u4EF6 <br> https://").concat(_this.uo.server, "/?q=").concat(_this.uo.board.split(".")[0], "&d=").concat(y.year)]);
                        }
                    }
                });
            }
            if (by_bbs) {
                by_bbs.reverse().map(function (b) {
                    lines.push([b.bbs, "", "".concat(b.bbs, " ").concat(b.count, "\u4EF6 <br> https://").concat(_this.uo.server, "/?q=").concat(_this.uo.board.split(".")[0], "&bbs=").concat(b.bbs)]);
                });
            }
            if (lines[0]) {
                lines[0][3] = "".concat(decodeURIComponent(this.uo.board), " - \u304B\u3053\u308D\u3050\u03B2");
            }
        }
        catch (e) {
        }
        return lines.map(function (l) { return l.join(_this.site_option.dsv_thread_delimiter); }).join("\n");
    }
};
exports.ThreadOverride = ThreadOverride;
var PostOverride = {};
exports.PostOverride = PostOverride;
